var pelicanURI = "http://www19.nittsu.co.jp/confirm/";
var widgetURI = "http://www2.atwiki.jp/macstar/pages/21.html";
var httpReq;
var lastCheckTime = 0;

// Widget 初期化
function init() {
	if (window.widget)
		widget.onshow = onShow;

	// XMLHttpRequest
	httpReq = new XMLHttpRequest();
	httpReq.onreadystatechange = processReqChange;

	// 裏面の Done ボタン
	createGenericButton (document.getElementById("done"), "完了", hidePrefs);
}

function onShow() {
	var now = (new Date).getTime();

	// 最後の問い合わせから 15 分以上経過していたら再問い合わせする
	if (15 * 60 * 1000 <= (now - lastCheckTime))
		formEdited();
}

// フォームからの入力
function formEdited() {
	var input = document.getElementById("numberField").value;
	var number, bit, drn;

	LOG__("formEdited");
	if (input != "") {
		number = input.replace(/[^0-9]/g, "");

		// アロー便チェック : 11 桁且つ先頭が"8"の場合、無条件に OK とする
		if (number.length == 11) {
			number = "0" + number;
			if (Number(number.substr(1,1) == 8)) {
				LOG__("number:" + number);
				inquiry(number);
				return true;
			}
		}

		if (number.length == 12) {
			// セブン DR チェック
			bit = Number(number.substr(11,1));
			drn = Number(number.substr(0,11)) % 7;
			if (bit == drn) {
				LOG__("number:" + number);
				inquiry(number);
				return true;
			}
		}

		alert("伝票番号が間違っています:" + number);
		return false;
	}
}

// 問い合わせ開始
function inquiry(number) {
	var now = (new Date).getTime();
	var uri = pelicanURI + "list.php?regist=%8C%9F%8D%F5%8AJ%8En";	// "検索開始" @ Shift_JIS

	lastCheckTime = now;
	LOG__("inquiry(" + number + ")");
	document.getElementById("result").innerHTML = "問い合わせています...";
	// HTTPリクエスト（非同期読み込み）
	httpReq.open("POST", uri, true);
	httpReq.setRequestHeader("Referer", "http://www.nittsu.co.jp/pelican/noflash.htm");
	httpReq.send("arr1=" + number);
}

// リクエスト状態（readyState）が変わったときに呼び出される
function processReqChange() {
	var buffer = new Array();
	var httpHeader = "";
	var htmlDoc = "";
	var i;

	// デバッグ用
	if (httpReq.readyState != 0) { // readyState 0 = uninitialized
		document.getElementById("status").innerText = httpReq.status;
		document.getElementById("header").innerText = httpReq.getAllResponseHeaders();
		document.getElementById("source").innerText = httpReq.responseText;
	}

	if (httpReq.readyState == 4) { // readyState 4 = complete
		if (httpReq.status == 200) {						// 200:ダウンロード成功
			httpHeader = httpReq.getAllResponseHeaders();	// レスポンスヘッダ
			htmlDoc = httpReq.responseText;					// HTMLソース
			document.getElementById("source").innerText = htmlDoc;
			parseHTML(htmlDoc);
		}
	}
}

// HTML から情報を取り出す
function parseHTML(htmlDoc) {
	var buffer = "";
	var index = 0;
	var number = ""
	var status = ""
	var detailHref = "";

	LOG__("parseHTML");
	// 伝票番号と詳細情報へのリンク
	if (htmlDoc.match(/<a href="\.\/(detail\.php[^"]*)">([^<]+)<\/a>/)) {		// "
		detailHref = pelicanURI + RegExp.$1;
		buffer = RegExp.$2;
		if (buffer.match(/([0-9\-]+)/))
			number = RegExp.$1;

		// 全角スペース除去
		detailHref = detailHref.replace(RegExp(String.fromCharCode(0x3000),"g"), "");
		LOG__(detailHref);
	}

	// 配達状況
	buffer = "";
	index = htmlDoc.indexOf("<a href=\"./detail.php")	// "
	if (0 <= index)
		buffer = htmlDoc.substr(index);

	index = buffer.indexOf("<td")	// "
	if (0 <= index)
		buffer = buffer.substr(index);

	index = buffer.indexOf("</td>")	// "
	if (0 <= index)
		buffer = buffer.substr(0, index);

	buffer = buffer.replace(/<[^>]+>/g, "");
	status = buffer.replace(/\n/g, "");

	// 情報表示
	if (number && status && detailHref) {
		LOG__("number:" + number + "\nstatus:" + status + "\ndetailHref:" + detailHref);
		displayResult(number, status, detailHref);
	} else {
		LOG__("Parse error.");
		displayError();
	}
}

// 情報表示
function displayResult(number, status, detailHref) {
	var result = document.getElementById("result");
	var anchor = document.createElement("span");

	LOG__("displayResult");
	document.getElementById("numberField").value = number;
	result.innerHTML = status;
	anchor.innerText = number;
	anchor.setAttribute("onclick", "goDetail('" + detailHref + "');");
	anchor.setAttribute("class", "goDetail");
	anchor.setAttribute("title", "詳細情報ページを WWW ブラウザで開く");
	result.appendChild(anchor);
}

// 表示情報クリア
function displayError() {
	var result = document.getElementById("result");
	LOG__("displayError");
	result.innerHTML = "見つかりません。";
}

// WWW ブラウザで詳細を表示
function goDetail(uri) {
	goWWW(uri);
}

function goWidgetPage() {
	goWWW(widgetURI);
}

function goWWW(uri) {
	var activeApp
	LOG__("goDetail(" + uri + ")");
	if (window.widget) {
		// widget.openURL を使いたかったけどうまくいかないので、プラグインで代替
		if (openURLPlugin) {
			activeApp = openURLPlugin.open(uri);
			widget.openApplication(activeApp);
		} else {
			alert("Widget plugin not loaded.");
		}
	} else {
		window.location.href = uri;
	}
}

// ひっくりかえす（Dashboard Programming Guide より）
function showPrefs() {
	if (window.widget)
		widget.prepareForTransition("ToBack");

	document.getElementById("front").style.display = "none";
	document.getElementById("back").style.display = "block";

	if (window.widget)
		setTimeout ("widget.performTransition();", 0);  
}

function hidePrefs() {
	if (window.widget)
		widget.prepareForTransition("ToFront");

	document.getElementById("front").style.display = "block";
	document.getElementById("back").style.display = "none";

	if (window.widget)
		setTimeout ("widget.performTransition();", 0);
}

// アニメーション関連（Dashboard Programming Guide より）
var flipShown = false;
var animation = {duration:0, starttime:0, to:1.0, now:0.0, from:0.0, firstElement:null, timer:null};

function mousemove(event) {
	if (!flipShown) {
		if (animation.timer != null) {
			clearInterval(animation.timer);
			animation.timer = null;
		}
		var starttime = (new Date).getTime() - 13;
		animation.duration = 500;
		animation.starttime = starttime;
		animation.firstElement = document.getElementById("flip");
		animation.timer = setInterval("animate();", 13);
		animation.from = animation.now;
		animation.to = 1.0;
		animate();
		flipShown = true;
	}
}

function mouseexit(event) {
	if (flipShown) {
		// fade in the info button
		if (animation.timer != null) {
			clearInterval (animation.timer);
			animation.timer  = null;
		}
		var starttime = (new Date).getTime() - 13;
		animation.duration = 500;
		animation.starttime = starttime;
		animation.firstElement = document.getElementById("flip");
		animation.timer = setInterval("animate();", 13);
		animation.from = animation.now;
		animation.to = 0.0;
		animate();
		flipShown = false;
	}
	exitflip();
}

function animate() {
	var T;
	var ease;
	var time = (new Date).getTime();
	T = limit_3(time-animation.starttime, 0, animation.duration);
	if (T >= animation.duration) {
		clearInterval (animation.timer);
		animation.timer = null;
		animation.now = animation.to;
	} else {
		ease = 0.5 - (0.5 * Math.cos(Math.PI * T / animation.duration));
		animation.now = computeNextFloat (animation.from, animation.to, ease);
	}
	animation.firstElement.style.opacity = animation.now;
}

function limit_3 (a, b, c) {
	return a < b ? b : (a > c ? c : a);
}

function computeNextFloat (from, to, ease) {
	return from + (to - from) * ease;
}

function enterflip(event) {
	document.getElementById("fliprollie").style.display = "block";
}

function exitflip(event) {
	document.getElementById("fliprollie").style.display = "none";
}

// デバッグ
function LOG__(arg) {
//	alert(arg);
}

