#import "MyPluginClass.h"

@implementation MyPluginClass

- (id)initWithWebView:(WebView*)w {
	self = [super init];
	return self;
}

- (void)dealloc {
	[super dealloc];
}

- (void)windowScriptObjectAvailable:(WebScriptObject*) windowScriptObject {
	[windowScriptObject setValue:self forKey:@"openURLPlugin"];
}

+ (NSString*)webScriptNameForSelector:(SEL)aSelector {
	if (aSelector == @selector(open:))
		return @"open";
	NSLog(@"\tunknown selector");
	return nil;
}

+ (BOOL)isSelectorExcludedFromWebScript:(SEL)aSelect {	
	if (aSelect == @selector(open:))
		return NO;
	return YES;
}

+ (BOOL)isKeyExcludedFromWebScript:(const char*)k {
	return YES;
}

// open URL with WWW Browser
- (NSString *)open:(NSString *)str {
	NSURL			*url;
	NSString		*bundleID = @"com.apple.Safari";
	NSDictionary	*activeApp;
	id object;

	url = [NSURL URLWithString:str];
	[[NSWorkspace sharedWorkspace] openURL:url];

	activeApp = [[NSWorkspace sharedWorkspace] activeApplication];
	object = [activeApp objectForKey:@"NSApplicationBundleIdentifier"];
	if (object)
		bundleID = object;
	else
		NSLog(@"cannot find NSApplicationBundleIdentifier");

	// Return bundle identifier of active application (default WWW browser)
	return bundleID;
}

/*
	Usage:
	if (window.widget) {
		if (openURLPlugin) {
			activeApp = openURLPlugin.open(uri);
			widget.openApplication(activeApp);
		} else {
			alert("Widget plugin not loaded.");
		}
	} else {
		window.location.href = uri;
	}
*/

@end
